# The general goals of this project

With this project we aim to find solutions, or approximations thereof, for the linear equation A·x=b. We use different solvers, meassure the number of iterations they need to reach the same accuracy and thereafter compare the results. This is done to investigate the order of convergence for the given solvers and consequently to determine the fastest algorithms.

In the following short descriptions of the files, which are included in this project, are given.

## [main.py](./main.py)
main.py is a used to start the jobs. These usually consist of generating the grid under preset parameters, running the varying solvers on said grid, storing the results and thereafter deleting these objects in order to free ram. If executed, the main function ```do_comparison()``` is run with default settings.

## [basic.py](./basic.py)
The classes defined within this file define the basic grid and the parameters necessary for a computation. This includes the initial values or  stencils, but does not include results, which are stored in the corresponding solver classes.
There are the

1.  parent parameters_base class, which is complete but a dummy finite difference stencil for the z-advection and the children classes
* parameters, which uses first order upwind finite differences, and
* paramters_high, which employs second upwind finite differences for the discretization of the z-advection.

## [boundaries.py](./boundaries.py)
Basically comprises a collection of small, independent functions. Each defines a specific set of boundary values, which are described in more detail in the corresponding comments.

## [solvers.py](./solvers.py)
From the solver class all further solving algorithms are inherited. Therefore it includes all the necessary data structures and logic to the is needed by those algorithms. Also the resulting grid is also stored within the solver objects.

## [data.py](./solvers.py)
The data class is used to store the results in conjunction with all the information necessary to make sense to them. This class has data importers from the solver class and also from json files. It has exporters to csv and json respectively.

## [data_evaluation.py](./data_evaluation.py)
This class uses two data objects: in the first one glbl all the data is imported to. Then it is possible to apply filters. All the valid data sets are then stored in the second data object. This is done in order to gain combined results and also to generate plots.

## [plot.py](./plot.py)
This file is basically a sequential script which generates all set plots. The data structuring is done based upon a data_evaluation object.
