from sys import exit
import collections
from numpy import mean,all
from scipy.optimize import curve_fit

from data import *

class evaluate(object):
    def __init__(self,glbl):
        """This class uses the input data object glbl as basis and generates a subset of it in the data object."""
        self.glbl=glbl;
        self.data=data();

    def reduce(self,boundaries=None,solvers=None,xis=None,grid=None,kappas=None,state=None,flags=[],lambdas=None,parameters=None):
        """Generate a new data subset from the glbl data with the given filters."""
        self.data.clear()
        for element in self.glbl.data:
            if boundaries != None and element['boundary'] not in boundaries: continue;
            if solvers != None and element['solver'] not in solvers: continue;
            if xis != None and element['xi'] not in xis: continue;
            if grid != None and element['n_z'] not in grid: continue;
            if flags != [] and set(flags).isdisjoint(set(element['flags'])): continue
            if kappas != None and element['kappa'] not in kappas: continue;
            if lambdas != None and element['lambda'] not in lambdas: continue;
            if parameters != None and element['parameters'] not in parameters: continue;
            if state != None and 'state' in element and element['state']!= state:
                print('State not equal:',element['boundary'],element['solver'],element['xi'],element['n_z'])
                continue
            self.data.append(element);

    def get_variable_data(self,variable='xi',value='iterations',state=None,function = lambda x: x):
        """Returns arrays with all the available variable and corresponding arrays. It is possible to run other functions over the findal values."""
        tmp={}
        state_list={}
        var=[]
        data=[]
        for element in self.data.data:
            if variable in element and element[variable] not in tmp:
                tmp[element[variable]] = []
                state_list[element[variable]] = []
            tmp[element[variable]].append(element[value])
            if state != None and element['state'] != state:
                state_list[element[variable]].append(False)
            else:
                state_list[element[variable]].append(True)

        for key,val in sorted(tmp.items()):
            if not all(state_list[key]):
                continue
            var.append(key);
            data.append(function(val))

        return var,data

    def compute_cost(self):
        pass

def curve_fitter(xdata,ydata):
    def func(n,a,b):
        return a* n**b;
    #print(xdata,ydata)
    popt, pcov = curve_fit(func, xdata, ydata)

    print("$f="+str(popt[0])+"\cdot n^{"+str(popt[1])+"}$")
